---
.title = "Book - Stolen Focus",
.author = "Martin Ashby",
.date = @date("2022-05-07T15:18:58+01:00"),
.layout = "single.html",
.custom = {"comments": true},
---

I've recently finished reading [Stolen Focus](stolenfocusbook.com/) by Johann Hari. 

In it, the author presents an argument that online social media (i.e. facebook, instagram, etc) is currently harmful, and this is because of misaligned incentives. The companies producing this software are funded by advertisers, whose adverts are more effective if they spend more time in front of user's eyes. This results in platforms optimizing for 'engagement' among users; i.e. more time spent on the site. Human negative reactions are stronger, and causing these emotions keeps users on the site for longer than positive ones. Therefore to increase screen time, platforms end up presenting stories that enrage the user. This has a variety of negative impacts including; polarizing the user's beliefs, adding stress and alienating other people. 

I hadn't come across this particular argument before, it seems fairly compelling. It rests on a couple of premises, for which Johann provides some evidence; 
* Social media companies are indeed optimizing for 'screen time' engagement in order to maximize profit.
* Optimizing for increased screen time does indeed result in the negative effects (wasted time, stress, polarization)

Johann suggests banning this business model. Only when the companies' incentives are aligned with the users of their product can they instead optimize their product in a way that improves the users' quality of life. Two suggestions for changing the business model are proposed; 1. charging users for the product, 2. acquisition by government. Neither suggestion is without it's own significant problems.

The book also touches on many other subjects, in fact the author lists around a dozen reasons why our attention span today is more limited than in the past. These include increased air pollution and decreased childhood freedom for example. He also makes the critical point that a failing attention span is not only a personal problem; while there is personal variation, the wider environment has a huge impact. This means that personal efforts to improve the situation are more likely to be stymied. This is similar to some other problems like obesity; where e.g. the environment is full of cheap, sugary, processed, high-fat foods, and yet people feel solely responsible when they gain excess weight, or fail to lose it.

Personally, the book has made me more conscious of my personal habits regarding my phone & social media usage. It has also made me more conscious of my work as a software enginneer; that misaligned incentives can have very negative consequences for users of your software. You should find a business model that somehow translates increased quality of life for users into profit. It also highlighted the importance of collective action for improving society; we should remember that our high quality of life right now is a direct result of many collective actions in the past.
