---
.title = "Blogsite",
.author = "Martin Ashby",
.date = @date("2022-10-14T22:59:01+01:00"),
.layout = "single.html",
.custom = {"comments": true},
---

I was thinking about this blog and how it's set up. I [covered](posts/2021-10-01-blog/) the setup in a previous post, but it's quite simple: the site is generated from markdown files with [hugo](https://gohugo.io/) and published to git. The server pulls from git on a schedule, rebuilds it and copies it to the web server directory.

I made a [little experiment](https://blogsite.mfashby.net/1-hello-new-blog) with a different approach [source](https://code.mfashby.net/martin/blogsite). Instead of statically generating the site, it's a Single Page Application which does the templating and routing on the client side. In theory this has a couple of upsides: if you visit multiple pages fewer bytes are transferred overall, and it totally removes the static site generation step; the folder is all just static content provided to the web server. This approach likely has some downsides too, like; requires javascript enabled client, no RSS feed or sitemap generation, and my implementation at least is relying on some fairly modern JS features like async/await and fetch API.

